package shop.alien.util.common;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;

import java.util.ArrayList;
import java.util.List;

/**
 * 将 List 转换为 IPage 对象
 *
 * @author ssk
 * @version 1.0
 * @date 2024/12/25 14:32
 */
public class ListToPage {

    /**
     * 将 List 转换为 IPage 对象。
     *
     * @param <T>      泛型类型
     * @param list     数据列表
     * @param pageNum  当前页码
     * @param pageSize 每页大小
     * @return 分页对象
     */
    public static <T> IPage<T> setPage(List<T> list, Integer pageNum, Integer pageSize) {
        IPage<T> iPage = new Page<>(pageNum, pageSize);
        iPage.setTotal(list.size());
        iPage.setCurrent(pageNum);
        iPage.setSize(pageSize);
        int pages = (int) Math.ceil((double) iPage.getTotal() / iPage.getSize());
        iPage.setPages(pages);
        int fromIndex = (pageNum - 1) * pageSize;
        int toIndex = Math.min(pageNum * pageSize, list.size());
        List<T> records = new ArrayList<T>();
        if(fromIndex <= toIndex && fromIndex >= 0){
            records = list.subList(fromIndex, toIndex);
        }
        iPage.setRecords(records);
        return iPage;
    }

}
